/*
 * Copyright (c) 2012, ToshiakiAsazuma All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * ERedistributions of source code must retain the above copyright notice, this
 *  list of conditions and the following disclaimer.
 *  
 * ERedistributions in binary form must reproduce the above copyright notice,
 *  this list of conditions and the following disclaimer in the documentation
 *  and/or other materials provided with the distribution.
 *  
 * ENeither the name of the ToshiakiAsazuma nor the names of its contributors
 *  may be used to endorse or promote products derived from this software
 *  without specific prior written permission.
 *  
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 *  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package jp.sourceforge.android_ab.addressbook.common.helper;

import jp.sourceforge.android_ab.addressbook.common.data.PageDataBean;
import jp.sourceforge.android_ab.addressbook.history.adapter.ContactHistoryListDataAdapter;
import jp.sourceforge.android_ab.addressbook.history.data.ContactHistoryDataBean;
import android.content.Context;
import android.database.Cursor;
import android.provider.CallLog.Calls;


public class ContactHistoryListDataHelper extends BaseDataHelper<PageDataBean<ContactHistoryDataBean>> {

	public ContactHistoryListDataHelper(Context context) {
		super(context);
	}

	@Override
	public PageDataBean<ContactHistoryDataBean> getDataBean() {
		PageDataBean<ContactHistoryDataBean> pageDataBean = new PageDataBean<ContactHistoryDataBean>(getContext(), new ContactHistoryListDataAdapter(getContext()));
		
		Cursor cursor = getContentResolver().query(Calls.CONTENT_URI, null, null, null, Calls.DEFAULT_SORT_ORDER);
		
		while (cursor.moveToNext()) {
			ContactHistoryDataBean dataBean = new ContactHistoryDataBean();
			dataBean.setName(cursor.getString(cursor.getColumnIndex(Calls.CACHED_NAME)));
			dataBean.setNumber(cursor.getString(cursor.getColumnIndex(Calls.NUMBER)));
			
			pageDataBean.add(dataBean);
		}
		
		return pageDataBean;
	}
}
